package bighornSheep75;

import java.awt.Color;
import java.util.LinkedList;
import java.util.List;
import java.util.Random;

import repast.simphony.context.Context;
import repast.simphony.engine.environment.RunEnvironment;
import repast.simphony.engine.schedule.ScheduledMethod;
import repast.simphony.parameter.Parameters;
import repast.simphony.query.space.grid.GridCell;
import repast.simphony.query.space.grid.GridCellNgh;
import repast.simphony.random.RandomHelper;
import repast.simphony.space.continuous.ContinuousSpace;
import repast.simphony.space.continuous.NdPoint;
import repast.simphony.space.grid.Grid;
import repast.simphony.space.grid.GridPoint;
import repast.simphony.util.ContextUtils;
import repast.simphony.util.SimUtilities;

//*************************************************************************************************
//Characterizes bighorn sheep agent behaviour
//*************************************************************************************************
public class agent {
	protected ContinuousSpace<Object> space;
	protected Grid<Object> grid;
	protected GridPoint current;
	protected GridPoint previous;
	
	public agent(Grid<Object> grid, ContinuousSpace<Object> space)
	{
		this.grid=grid;
		this.space=space;
	}
	
//-------------------------------------------------------------------------------------------------
//method to select a neighbouring gridcell to move to and then to move.
//------------------------------------------------------------------------------------------------
	public void move()
	{ 
		current = grid.getLocation(this);
		if(previous== null)
			previous = current;
		List<GridCell<agent>> neighbourhood = new GridCellNgh<agent>(grid,
				current, agent.class, 1,1).getNeighborhood(false); 
		List<movementList> movementLinkedList= new LinkedList<movementList>();
		SimUtilities.shuffle(neighbourhood, RandomHelper.getUniform());
		
		GridPoint pt = null;
		for(GridCell cell: neighbourhood)
		{
			pt = cell.getPoint();
			movementList newCell = new movementList(pt.getX(), pt.getY(), current.getX(), current.getY(), this.grid, this.space);
			movementLinkedList.add(newCell);
			if(newCell.getLake() !=-9999 )
			{movementLinkedList.remove(newCell);}
		
		}
		
		movementList thisOne = null;
		for(int i = 0; i < movementLinkedList.size(); i++ )
		{
			if(movementLinkedList.get(i).getX() != previous.getX() && movementLinkedList.get(i).getY()!=previous.getY())
			if(movementLinkedList.get(i).satisfiesEscapeTerrain()==true)
					if(movementLinkedList.get(i).getCover()<40)
						if(movementLinkedList.get(i).getRiver()==-9999)
							if(movementLinkedList.get(i).getRoad()== -9999)
							{
									thisOne = movementLinkedList.get(i);
									
								}
		}

	
		if(thisOne == null) 
		{
			Context context = ContextUtils.getContext(this); //Note: uncomment these lines if running multi-agent simulation
            context.remove(this); 
			//RunEnvironment.getInstance().endRun();	
		}
		else{
		previous = current;
		grid.moveTo(this, (int) thisOne.getX(),(int) thisOne.getY());	
		space.moveTo(this, thisOne.getX(), thisOne.getY());
		}
		}
//-------------------------------------------------------------------------------------------------
//Scheduled method to run every time step. If all agents have been removed from the context,
//ends the simulation. Otherwise, calls the move method.
//------------------------------------------------------------------------------------------------
	@ScheduledMethod(start =1, interval =1)	
	public void step()
	{ 
			//System.out.println("step");
		Context context = ContextUtils.getContext(this);
		if(context.size() <=2)
		{
		RunEnvironment.getInstance().endRun();
		}
		
		if(RunEnvironment.getInstance().getCurrentSchedule().getTickCount() == 2000)
			{
			RunEnvironment.getInstance().endRun();	
			}
		
			current = grid.getLocation(this);	
			if(current != null)
			this.move();
			
			else{context.remove(this);
			
			}
	}	
	
	public int getLocationX()
	{return this.current.getX();}
	
	public int getLocationY()
	{return this.current.getY();}
	
	public int getEscapeTerrain()
	{
		Parameters params = RunEnvironment.getInstance().getParameters();
	return (Integer) params.getValue("escapeTerrain");
	}

	public int getCover()
	{
		Parameters params = RunEnvironment.getInstance().getParameters();
	return (Integer) params.getValue("crownCover");
	}
}


