package bighornSheep75;

import java.awt.Color;
import java.util.List;
import java.util.Random;

import repast.simphony.engine.environment.RunEnvironment;
import repast.simphony.parameter.Parameters;
import repast.simphony.query.space.grid.GridCell;
import repast.simphony.query.space.grid.GridCellNgh;
import repast.simphony.random.RandomHelper;
import repast.simphony.space.SpatialMath;
import repast.simphony.space.continuous.ContinuousSpace;
import repast.simphony.space.continuous.NdPoint;
import repast.simphony.space.grid.Grid;
import repast.simphony.space.grid.GridPoint;
import repast.simphony.util.SimUtilities;


public class movementList {
	private int x, y;
	private int foragingValue;
	private int riverValue;
	private int lakeValue;
	private int roadValue;
	private int coverValue;
	protected Grid<Object> grid;
	private ContinuousSpace space;
	private double cellSize = GIS.slope.getCellSize();
	
	public movementList(int x, int y,int cx, int cy, Grid grid, ContinuousSpace space)
	{
		this.x = x;
		this.y = y;
		this.grid = grid;
		this.space = space;
		

		if(GIS.river.getSizeX()> x && GIS.river.getSizeY() > y)
			this.riverValue=GIS.river.get(x,y);
		else this.riverValue = -9999;

		
		if(GIS.crownCover.getSizeX()> x && GIS.crownCover.getSizeY() > y)
			this.coverValue=GIS.crownCover.get(x,y);
		else this.coverValue = -9999;
		
		if(GIS.lakes.getSizeX()> x && GIS.lakes.getSizeY() > y)
			this.lakeValue = GIS.lakes.get(x,y);
		else this.lakeValue = -9999;
		
		if(GIS.roads.getSizeX()> x && GIS.roads.getSizeY() > y)
			this.roadValue = GIS.roads.get(x,y);
		else this.roadValue = -9999;
			
	}
	public int getCover()
	{return this.coverValue;}
	
	public int getRoad()
	{return this.roadValue;}
	
	public int getRiver()
	{return this.riverValue;}
	
	public int getForaging()
	{return this.foragingValue;}
	
	public int getLake()
	{return this.lakeValue;}

	
//------------------------------------------------------------------------
//returns a Boolean solution indicating if the movement option in question
//is within an appropriate distance to escape terrain to be acceptable for
//movement.
//-------------------------------------------------------------------------
	public boolean satisfiesEscapeTerrain()
	{

		Parameters params = RunEnvironment.getInstance().getParameters();
	
		GridPoint current = new GridPoint(x,y);
		boolean output = false;
		
	//	int PR =  (800/ (int)cellSize) * 2 + 1; //calculates how far the neighbourhood needs to query based on cell size
		int PR = 25;
		List<GridCell<agent>> neighbourhood = new GridCellNgh<agent>(grid,
				current, agent.class, PR,PR).getNeighborhood(false); 	
		SimUtilities.shuffle(neighbourhood, RandomHelper.getUniform());
		Random random = new Random();
		int probability = random.nextInt(100);

		for(GridCell cell: neighbourhood)
		{
			GridPoint thisPoint = cell.getPoint();
			if(GIS.slope.get(thisPoint.getX(), thisPoint.getY()) > 40 && GIS.slope.get(thisPoint.getX(), thisPoint.getY()) !=-9999)
			{	int distance = (int) grid.getDistance(current, thisPoint);
				
				if(probability < 188.2072061833*(Math.exp(-0.00158093*distance*75)))
					{output = true;
					
					break;
					}
			}
		}
		return output;	
	}

	
	public double getX()
	{
		return this.x;
		}
	public double getY()
	{
		return this.y;
	}

		
	
	
	
}
